<template>
  <div id="app">
    <img src="/PNISZ.svg" width="320" /><br>
    <button @click="connect">Connect</button>
    <button @click="buzz">Buzz</button><br/><br/>
    <select v-model="deck">
      <option disabled>Select deck</option>
      <option v-for="(deck, deckIndex) in decks" :key="deckIndex" :value="deckIndex">{{ deck.name }}</option> 
    </select><br/>
    <input type="text" v-model="name" /><br/>
    <button @click="addDeck">Add deck</button>&nbsp;
    <button @click="addItem">Add item</button>
    <br/><br/>
    <div>{{ decks }}</div>
    <br/><br/>
    <div v-for="(deck, deckIndex) in decks" :key="deckIndex">
      <h1>{{ deck.name }}</h1>
      <div v-for="(item, itemIndex) in deck.items" :key="itemIndex">"{{ item }}"</div>
    </div>
  </div>
</template>

<script>
import imageJS from '../public/logo';
export default {
  name: 'App',
  data: () => ({
    display: null,
    deck: null,
    name: null,
    selectedDeck: 0,
    selectedItem: 0,
    decks: [],
    interval: null,
    pagerIndex: 0,
    pager: [],
    imageData: imageJS
  }),
  mounted() {
    // /Tws\n$<text>\n // ha több soros \n csere \r-re
    const app = document.querySelector('#app');
    const scr = document.createElement('script');
    scr.src = "/lib/devices.js";
    app.appendChild(scr);
  },
  methods: {
    async connect() {
      // eslint-disable-next-line no-undef
      const display = new PeekSmithDevice();
      await display.connect();
      this.display = display;
      this.display.onMessage(this.onData);
      display.displayText('Puska 1.0');
      window.showLogo = this.showLogo;
    },
    async showLogo() {
      const maxChunkSize = 60;
      await this.display.sendCustom([32, 255, 0, this.imageData.width, 0, this.imageData.height, 16]);
      let offset = 0;
      while (offset < this.imageData.data.length) {
        const chunkSize = Math.min(offset === 0 ? maxChunkSize : maxChunkSize - 5, this.imageData.data.length - offset);
        console.log('Uploading image... ' + offset, this.imageData.data.slice(offset, offset + chunkSize));
        await this.display.sendCustom([33, offset >> 8, offset % 256, ...this.imageData.data.slice(offset, offset + chunkSize)]);
        offset += chunkSize;
      }
      await this.display.sendCustom([31, 255]);
    },
    buzz() {
      this.display.send("/VL511\n~..\n");
      setTimeout(() => {
        this.display.send("/VL211\n~....\n");
      }, 1500);
    },
    addDeck() {
      const deck = { name: this.name, items: [] };
      this.decks.push(deck);
      this.reset();
    },
    addItem() {
      if (!`${this.deck}` || !this.name) return;
      this.decks[this.deck].items.push(this.name);
      this.reset();
    },
    onData(data) {
      console.log('data', data.includes('isb1,release'))
      if (data.includes('isb1,release')) {
        clearInterval(this.interval);
        let nextIndex = this.selectedDeck + 1;
        if (this.decks.length <= nextIndex) nextIndex = 0;
        this.selectedDeck = nextIndex;
        console.log('nextIndex', nextIndex);
        this.selectedItem = 0;
        this.displayDeckName();
      }
      if (data.includes('isb2,release')) {
        clearInterval(this.interval);
        let nextIndex = this.selectedItem + 1;
        const deck = this.decks[this.selectedDeck];
        if (deck && deck.items.length <= nextIndex) nextIndex = 0;
        this.selectedItem = nextIndex;
        console.log('nextIndex', nextIndex);
        this.displayItem();
      }
    },
    displayDeckName() {
      console.log('deck', this.decks, this.selectedDeck)
      if (this.decks.length) {
        this.display.displayText(this.decks[this.selectedDeck].name);
      }
    },
    displayItem() {
      const deck = this.decks[this.selectedDeck];
      const item = deck.items[this.selectedItem];
      if (item.length > 70) {
        this.pager = item.match(/.{42}/g)
        console.log('pager', this.pager)
        this.display.displayText(this.pager[0]);
        this.interval = setInterval(() => {
          this.pagerIndex = this.pager.length <= this.pagerIndex + 1 ? 0 : this.pagerIndex + 1;
          this.display.displayText(this.pager[this.pagerIndex]);
        }, 2500);
      } else {
        this.display.displayText(item);
      }
    },
    reset() {
      this.deck = null;
      this.name = null;
    }
  }
}
</script>

<style>
#app {
  font-family: Avenir, Helvetica, Arial, sans-serif;
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
  text-align: center;
  color: #2c3e50;
  margin-top: 60px;
}
</style>
